<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
class woo2app_metabox_notif
{
	function __construct()
	{
		add_action( 'add_meta_boxes', array($this , 'woo2app_metabox_notif_add') );
		add_action( 'save_post', array($this , 'woo2app_metabox_notif_save') );
		add_filter( 'excerpt_length', array($this , 'wp2appir_excerpt_length'), 999 );
	}
	function woo2app_metabox_notif_add()
	{
		add_meta_box( 'notif-woo-meta-box-id',
			'ارسال با نوتیفیکیشن (woo2app)',
			array($this , 'woo2app_notif_meta_box_design'),
			'product',
			'side',
			'high' );
	}
	function woo2app_notif_meta_box_design()
	{
		global $wpdb;
		$email = get_option('email_WOO2APP');
		$pass = get_option('password_WOO2APP');
		$appid = get_option('appid_WOO2APP');
		global $post;
		$values = get_post_custom( $post->ID );
		$check = isset( $values['my_meta_box_check'] ) ? esc_attr( $values['my_meta_box_check'] ) : '';
		// We'll use this nonce field later on when saving.
		wp_nonce_field( 'my_meta_box_nonce', 'meta_box_nonce' );
		?>
        <p>
            <input type="radio" name="notify" value="voice" > ارسال با صدا<br>
            <input type="radio" name="notify" value="silent"> ارسال بدون صدا<br>
            <input type="radio" name="notify" value="no_send" checked> عدم ارسال
        </p>
		<?php
		if( !$email && !$pass && !$appid ){
			?>
            <p>
                برای ازسال نوتیفیکیشن لاگین کنید.
                <a href="<?php menu_page_url('wp2appir/pages/wp2appir_login.php'); ?>">صفحه ورود</a></p>
			<?php
		}
	}
	function woo2app_metabox_notif_save( $post_id ){
		// Bail if we're doing an auto save
		if( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return;
		// if our nonce isn't there, or we can't verify it, bail
		if( !isset( $_POST['meta_box_nonce'] ) || !wp_verify_nonce( $_POST['meta_box_nonce'], 'my_meta_box_nonce' ) ) return;
		// if our current user can't edit this post, bail
		if( !current_user_can( 'edit_post' ) ) return;
		// now we can actually save the data
		$allowed = array(
			'a' => array( // on allow a tags
				'href' => array() // and those anchors can only have href attribute
			)
		);
		$email = get_option('email_WOO2APP');
		$pass = get_option('password_WOO2APP');
		$appid = get_option('appid_WOO2APP');
		if( $email != "" && $pass != "" && $appid != "" ){
			if(isset($_POST['notify']) and get_post_status($post_id)=="publish"){

				$email = get_option('email_WOO2APP');
				$pass = get_option('password_WOO2APP');
				$appid = get_option('appid_WOO2APP');
				if($_POST['notify']=='voice'){

					$data = array(
						"sound" => 1,
						"title" => "",
						"description" => get_the_title($post_id),
						"action" => 4,
						"value" => $post_id
					);
					$data = json_encode($data);
					$data = array(
						"data" => $data

					);

					//$data = "{'sound':'1','title':'','description':get_the_title($post_id),'action':'4','value': $post_id}";
					$ch = curl_init();
					curl_setopt($ch, CURLOPT_URL, "http://panel.wp2app.ir/panel/api/send_notification2all?email=$email&password=$pass&app_id=$appid");
					curl_setopt($ch, CURLOPT_HTTPHEADER, array(
						"Content-Type:multipart/form-data"
					));
					curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
					curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
					curl_setopt($ch, CURLOPT_POST, TRUE);
					curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
					$response = curl_exec($ch);
					curl_close($ch);
				}else if($_POST['notify']=='silent'){
					$data = array(
						"sound" => 2,
						"title" => "",
						"description" => get_the_title($post_id),
						"action" => 4,
						"value" => $post_id
					);
					$data = json_encode($data);
					$data = array(
						"data" => $data

					);

					//$data = "{'sound':'1','title':'','description':get_the_title($post_id),'action':'4','value': $post_id}";
					$ch = curl_init();
					curl_setopt($ch, CURLOPT_URL, "http://panel.wp2app.ir/panel/api/send_notification2all?email=$email&password=$pass&app_id=$appid");
					curl_setopt($ch, CURLOPT_HTTPHEADER, array(
						"Content-Type:multipart/form-data"
					));
					curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
					curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
					curl_setopt($ch, CURLOPT_POST, TRUE);
					curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
					$response = curl_exec($ch);
					curl_close($ch);
				}else{
					return;
				}
			}else{
				return;
			}
		}
	}
	function woo2app_excerpt( $post )
	{
		$text = $post->post_content;
		$text = strip_shortcodes( $text );
		$text = apply_filters( 'the_content', $text );
		$text = str_replace( ']]>', ']]>', $text );

		$excerpt_length = apply_filters( 'excerpt_length', 55 );
		$excerpt_more   = apply_filters( 'excerpt_more', ' ' . '[...]' );
		$text           = wp_trim_words( $text, $excerpt_length, '' );
		return $text;
	}

	function wp2appir_excerpt_length( $length ) {
		return 20;
	}
}